



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>day7_subprocess模块和面向对象,反射</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">day7_subprocess模块和面向对象,反射</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 13:30:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>常用subprocess方法示例</h4>
<blockquote><p><strong>#执行命令，返回命令执行状态 ， 0 or 非0</strong><br />&gt;&gt;&gt; retcode = subprocess.call(["ls", "-l"])</p>
<p>#执行命令，如果命令结果为0，就正常返回，否则抛异常<br />&gt;&gt;&gt; subprocess.check_call(["ls", "-l"])<br />0</p>
<p><strong>#接收字符串格式命令，返回元组形式，第1个元素是执行状态，第2个是命令结果 </strong><br />&gt;&gt;&gt; subprocess.getstatusoutput('ls /bin/ls')<br />(0, '/bin/ls')</p>
<p><strong>#接收字符串格式命令，并返回结果</strong><br />&gt;&gt;&gt; subprocess.getoutput('ls /bin/ls')<br />'/bin/ls'</p>
<p><strong>#执行命令，并返回结果，注意是返回结果，不是打印，下例结果返回给res</strong><br />&gt;&gt;&gt; res=subprocess.check_output(['ls','-l'])<br />&gt;&gt;&gt; res<br />b'total 0\ndrwxr-xr-x  12 alex  staff  408 Nov  2 11:05 OldBoyCRM\n'</p>
<p><strong>#上面那些方法，底层都是封装的subprocess.Popen</strong><br />poll()<br />    Check if child process has terminated.  Returns returncode</p>
<p>wait()<br />    Wait for child process to terminate.  Returns returncode attribute.</p>
<p>terminate() 杀掉所启动进程<br />communicate()  等待任务结束</p>
<p>stdin 标准输入</p>
<p>stdout 标准输出</p>
<p>stderr 标准错误</p>
<p>pid<br />    The process ID of the child process.</p>
<p><strong>#例子</strong><br />&gt;&gt;&gt; p = subprocess.Popen("df -h|grep disk",stdin=subprocess.PIPE,stdout=subprocess.PIPE,shell=True)<br />&gt;&gt;&gt; p.stdout.read()<br />b'/dev/disk1     465Gi   64Gi  400Gi    14% 16901472 104938142   14%   /\n'</p></blockquote>
<div>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
</td>
<td>
<div>
<div><code>&gt;&gt;&gt; subprocess.run([</code><code>"ls"</code><code>, </code><code>"-l"</code><code>])&nbsp; </code><code># doesn't capture output</code></div>
<div><code>CompletedProcess(args</code><code>=</code><code>[</code><code>'ls'</code><code>, </code><code>'-l'</code><code>], returncode</code><code>=</code><code>0</code><code>)</code></div>
<div>&nbsp;</div>
<div><code>&gt;&gt;&gt; subprocess.run(</code><code>"exit 1"</code><code>, shell</code><code>=</code><code>True</code><code>, check</code><code>=</code><code>True</code><code>)</code></div>
<div><code>Traceback (most recent call last):</code></div>
<div><code>&nbsp;&nbsp;</code><code>...</code></div>
<div><code>subprocess.CalledProcessError: Command </code><code>'exit 1'</code> <code>returned non</code><code>-</code><code>zero exit status </code><code>1</code></div>
<div>&nbsp;</div>
<div><code>&gt;&gt;&gt; subprocess.run([</code><code>"ls"</code><code>, </code><code>"-l"</code><code>, </code><code>"/dev/null"</code><code>], stdout</code><code>=</code><code>subprocess.PIPE)</code></div>
<div><code>CompletedProcess(args</code><code>=</code><code>[</code><code>'ls'</code><code>, </code><code>'-l'</code><code>, </code><code>'/dev/null'</code><code>], returncode</code><code>=</code><code>0</code><code>,</code></div>
<div><code>stdout</code><code>=</code><code>b</code><code>'crw-rw-rw- 1 root root 1, 3 Jan 23 16:23 /dev/null\n'</code><code>)</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
</div>
<p>调用subprocess.run(...)是推荐的常用方法，在大多数情况下能满足需求，但如果你可能需要进行一些复杂的与系统的交互的话，你还可以用subprocess.Popen(),语法如下：</p>
<div>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
</td>
<td>
<div>
<div><code>p </code><code>=</code> <code>subprocess.Popen(</code><code>"find / -size +1000000 -exec ls -shl {} \;"</code><code>,shell</code><code>=</code><code>True</code><code>,stdout</code><code>=</code><code>subprocess.PIPE)</code></div>
<div><code>print</code><code>(p.stdout.read())</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
</div>
<p>可用参数：</p>
<ul><ul><li>args：shell命令，可以是字符串或者序列类型（如：list，元组）</li>
<li>bufsize：指定缓冲。0 无缓冲,1 行缓冲,其他 缓冲区大小,负值 系统缓冲</li>
<li>stdin, stdout, stderr：分别表示程序的标准输入、输出、错误句柄</li>
<li>preexec_fn：只在Unix平台下有效，用于指定一个可执行对象（callable object），它将在子进程运行之前被调用</li>
<li>close_sfs：在windows平台下，如果close_fds被设置为True，则新创建的子进程将不会继承父进程的输入、输出、错误管道。<br />所以不能将close_fds设置为True同时重定向子进程的标准输入、输出与错误(stdin, stdout, stderr)。</li>
<li>shell：同上</li>
<li>cwd：用于设置子进程的当前目录</li>
<li>env：用于指定子进程的环境变量。如果env = None，子进程的环境变量将从父进程中继承。</li>
<li>universal_newlines：不同系统的换行符不同，True -&gt; 同意使用 \n</li>
<li>startupinfo与createionflags只在windows下有效<br />将被传递给底层的CreateProcess()函数，用于设置子进程的一些属性，如：主窗口的外观，进程的优先级等等</li></ul></ul>
<p>终端输入的命令分为两种：</p>
<ul><li>输入即可得到输出，如：ifconfig</li>
<li>输入进行某环境，依赖再输入，如：python</li></ul>
<p>需要交互的命令示例</p>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
</td>
<td>
<div>
<div><code>import</code> <code>subprocess</code></div>
<div>&nbsp;</div>
<div><code>obj </code><code>=</code> <code>subprocess.Popen([</code><code>"python"</code><code>], stdin</code><code>=</code><code>subprocess.PIPE, stdout</code><code>=</code><code>subprocess.PIPE, stderr</code><code>=</code><code>subprocess.PIPE)</code></div>
<div><code>obj.stdin.write(</code><code>'print 1 \n '</code><code>)</code></div>
<div><code>obj.stdin.write(</code><code>'print 2 \n '</code><code>)</code></div>
<div><code>obj.stdin.write(</code><code>'print 3 \n '</code><code>)</code></div>
<div><code>obj.stdin.write(</code><code>'print 4 \n '</code><code>)</code></div>
<div>&nbsp;</div>
<div><code>out_error_list </code><code>=</code> <code>obj.communicate(timeout</code><code>=</code><code>10</code><code>)</code></div>
<div><code>print</code> <code>out_error_list</code></div>
</div>
</td>
</tr>
</tbody>
</table>
<p>反射示例：</p>
<div>
<pre class="prettyprint linenums"> class Foo(object):

     def __init__(self):<br />
         self.name = 'wupeiqi'

     def func(self):<br />
         return 'func'

 obj = Foo()

 # #### 检查是否含有成员 ####<br />
 hasattr(obj, 'name')<br />
 hasattr(obj, 'func')

 # #### 获取成员 ####<br />
 getattr(obj, 'name')<br />
 getattr(obj, 'func')

 # #### 设置成员 ####<br />
 setattr(obj, 'age', 18)<br />
 setattr(obj, 'show', lambda num: num + 1)

 # #### 删除成员 ####<br />
 delattr(obj, 'name')<br />
 delattr(obj, 'func')</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7odv18.html">Java三大框架 介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqloz70q.html">ehcache memcache redis 三大缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z7m0d9.html">Cheatsheet&colon; 2015 07&period;01 ~ 07&period;31</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyjvexq.html">html知识2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmerkx9.html">微软DbHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1npk9.html">前端开发之-------------合理利用CSS的权重----------------</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ryp19.html">notepad&plus;&plus;采用正则表达式删除空行</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x7mrn9.html">&lbrack;Angular 2&rsqb; Create Shareable Angular 2 Components</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3ov09.html">小白日记35：kali渗透测试之Web渗透-手动漏洞挖掘（一）-默认安装引发的漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4eelq.html">Qt5&period;4静态编译方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m40okq.html">【Chromium中文文档】Chrome&sol;Chromium沙箱 - 安全架构设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxknlxv8.html">Servlet的学习之Session（5）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1on52q.html">DCL的失效：现实与初衷的背离</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ylnxg8.html">王垠：我和Google的故事</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjz62j8.html">开始记录学习java的笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zojn59.html">client&lowbar;v2&period;go</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2j159.html">&lbrack;转&rsqb;MapReduce&colon;详解Shuffle过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvkkmx8.html">【Mysql sql inject】【入门篇】sqli-labs使用 part 4【18-20】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j5g30q.html">zend studio调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1pjplq.html">061 hive中的三种join与数据倾斜</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q2p1o87.html">在Azure上的VM镜像库中找到想要的镜像</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2odw97.html">关于Net Core 多平台程序的Framework问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdnrz9d.html">基于redis的处理session的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv63o8x.html">&lbrack;示例&rsqb; Firemonkey OnTouch 多点触控应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/39ror490.html">应用SuperIO（SIO）和开源跨平台物联网框架ServerSuperIO（SSIO）构建系统的整体方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/49552z9z.html">Css3新特性总结之边框与背景&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1zz259.html">iOS 报错汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wjg3q.html">用collectionview实现瀑布流-转&lpar;后面附demo，供参考&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwdj7k8.html">A星寻路算法介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1zr569.html">Allocators与Criterion的相同点及区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
